Attribute VB_Name = "E5Aexp"
'/*======================================================================*/
'/* Source:     E5Aexp.bas
'/* Description:E5A exp data analysis functions.
'/* DOrded:
'/*  Ver.1.32 18.03/01 e5aGrAxSet() ǉ
'/*  Ver.1.31 18.02/14 e5aLogPk() InStr()rɕύX
'/*  Ver.1.30 16.11/10 SRIMfit֐Ăяo Application.Run
'/*  Ver.1.20 16.10/25 add LogPk() ֐ύX e5a**
'/*  Ver.1.10 15.09/24 add EDflgI2S()
'/*  Ver.1.00 15.08/18 A.Yoshida(RIKEN)
'/*======================================================================*/

'           ==== Functions =====

'       ( EDeg vZ )
'  e5aEDthkI(  EDt,Iptn)   IDZz    --> Total Thick
'  e5aEDthkS(  EDT,Sptn)   ID      --> Total Thick
'  e5aEDflgI2S(Iptn)       IDZz    --> ID
'     EDt   EDeg z               = {m,m, ...} 12vf
'     Iptn  gpEDeg ID ̃Zz  = {1,2,3,   ...} 12vf
'     Sptn  gpEDeg ID ̕    = "123456789ABC" 12

'       ( ȯEvZ )
'  e5adE_ICs( Erng, ... )  ICs  ̇E            [MeV/u]
'  e5adE_SSD1(Erng, ... )  SSD1 ̇E            [MeV/u]
'  e5adE_SSD2(Erng, ... )  SSD1ʉߌ SSD2̇E  [MeV/u]
'     Erng [MeV/u]         EDegoBeamEnergy    [MeV/u]


'       ( LabView LogV[g )
'  sub e5LogPk(...)     ̃}[Ns  PkUp ăRsy
'  sub e5aGrAxSet(...)  Ot X/Y min/max ꊇݒ

'/*======================================================================*/
Option Explicit
Option Base 0

'/*----------------------------------------------------------------------*/
' )EDtbl, EDflgI ̗vf(12) ̓`FbNĂȂB
'    As Range ̎QƔ͈͂́Ac or s ǂłǂB
'    z(Raw=1..12,Colum=1) ƂĈ炵B
'/*----------------------------------------------------------------------*/
'/*(Func.) EDeg total thick : using Integer array
'/*----------------------------------------------------------------------*/
Function e5aEDthkI(ByVal EDtbl As Range, ByVal EDflgI As Range) As Double
Dim ThTot As Double
    ThTot = 0
    If EDflgI(1) <> 0 Then ThTot = ThTot + EDtbl(1)
    If EDflgI(2) <> 0 Then ThTot = ThTot + EDtbl(2)
    If EDflgI(3) <> 0 Then ThTot = ThTot + EDtbl(3)
    If EDflgI(4) <> 0 Then ThTot = ThTot + EDtbl(4)
    If EDflgI(5) <> 0 Then ThTot = ThTot + EDtbl(5)
    If EDflgI(6) <> 0 Then ThTot = ThTot + EDtbl(6)
    If EDflgI(7) <> 0 Then ThTot = ThTot + EDtbl(7)
    If EDflgI(8) <> 0 Then ThTot = ThTot + EDtbl(8)
    If EDflgI(9) <> 0 Then ThTot = ThTot + EDtbl(9)
    If EDflgI(10) <> 0 Then ThTot = ThTot + EDtbl(10)
    If EDflgI(11) <> 0 Then ThTot = ThTot + EDtbl(11)
    If EDflgI(12) <> 0 Then ThTot = ThTot + EDtbl(12)
    e5aEDthkI = ThTot
End Function

'/*----------------------------------------------------------------------*/
'/*(Func.) EDeg total thick : using EDeg status String
'/*         eg.) "123456789ABC", "020006000000"  : "0" is OUT
'/*----------------------------------------------------------------------*/
Function e5aEDthkS(ByVal EDtbl As Range, ByVal EDflgS As String) As Double
Dim ThTot As Double
    ThTot = 0
    If Mid(EDflgS, 1, 1) <> "0" Then ThTot = ThTot + EDtbl(1)
    If Mid(EDflgS, 2, 1) <> "0" Then ThTot = ThTot + EDtbl(2)
    If Mid(EDflgS, 3, 1) <> "0" Then ThTot = ThTot + EDtbl(3)
    If Mid(EDflgS, 4, 1) <> "0" Then ThTot = ThTot + EDtbl(4)
    If Mid(EDflgS, 5, 1) <> "0" Then ThTot = ThTot + EDtbl(5)
    If Mid(EDflgS, 6, 1) <> "0" Then ThTot = ThTot + EDtbl(6)
    If Mid(EDflgS, 7, 1) <> "0" Then ThTot = ThTot + EDtbl(7)
    If Mid(EDflgS, 8, 1) <> "0" Then ThTot = ThTot + EDtbl(8)
    If Mid(EDflgS, 9, 1) <> "0" Then ThTot = ThTot + EDtbl(9)
    If Mid(EDflgS, 10, 1) <> "0" Then ThTot = ThTot + EDtbl(10)
    If Mid(EDflgS, 11, 1) <> "0" Then ThTot = ThTot + EDtbl(11)
    If Mid(EDflgS, 12, 1) <> "0" Then ThTot = ThTot + EDtbl(12)
    e5aEDthkS = ThTot
End Function

'/*----------------------------------------------------------------------*/
'/*(Func.) EDeg pattern : Int array -> String
'/*----------------------------------------------------------------------*/
Function e5aEDflgI2S(ByVal EDflgI As Range) As String
Dim EDS As String
    EDS = ""
    If EDflgI(1) <> 0 Then EDS = EDS + "1" Else EDS = EDS + "0"
    If EDflgI(2) <> 0 Then EDS = EDS + "2" Else EDS = EDS + "0"
    If EDflgI(3) <> 0 Then EDS = EDS + "3" Else EDS = EDS + "0"
    If EDflgI(4) <> 0 Then EDS = EDS + "4" Else EDS = EDS + "0"
    If EDflgI(5) <> 0 Then EDS = EDS + "5" Else EDS = EDS + "0"
    If EDflgI(6) <> 0 Then EDS = EDS + "6" Else EDS = EDS + "0"
    If EDflgI(7) <> 0 Then EDS = EDS + "7" Else EDS = EDS + "0"
    If EDflgI(8) <> 0 Then EDS = EDS + "8" Else EDS = EDS + "0"
    If EDflgI(9) <> 0 Then EDS = EDS + "9" Else EDS = EDS + "0"
    If EDflgI(10) <> 0 Then EDS = EDS + "A" Else EDS = EDS + "0"
    If EDflgI(11) <> 0 Then EDS = EDS + "B" Else EDS = EDS + "0"
    If EDflgI(12) <> 0 Then EDS = EDS + "C" Else EDS = EDS + "0"
    e5aEDflgI2S = EDS + "0"
End Function

'/*----------------------------------------------------------------------*/
'/*(Func.) dE in ICsmall
'/*     Erng            [MeV/u] Ebeam @ EDeg out
'/*     wsAir, wsMylar          SRIM Fit WS name
'/*     tAir2, tAirIC   [mm]    Air length
'/*     tMylar          [um]    Mylar thick @ IC entrance
'/*     hPa, degC       [hPa][C] of Air
'/*     return          [MeV/u]
'/*----------------------------------------------------------------------*/
'/* SRIMfit ̊֐ĂяóA Application.Run b\bhgp̎
'/*----------------------------------------------------------------------*/
Function e5adE_ICs(ByVal Erng As Double, _
    ByVal wsAir, wsMylar As String, _
    ByVal tAir2, hPa, degC, tMylar, tAirIC As Double) As Double
Dim E1, E2 As Double
    E1 = Application.Run("srEnewGas", wsAir, Erng, tAir2, hPa * 100, degC)
    E1 = Application.Run("srEnew", wsMylar, E1, tMylar)
    E2 = Application.Run("srEnewGas", wsAir, E1, tAirIC, hPa * 100, degC)
    e5adE_ICs = E1 - E2
End Function

'/*----------------------------------------------------------------------*/
'/*(Func.) dE in SSD1
'/*     Erng            [MeV/u] Ebeam @ EDeg out
'/*     wsAir, wsSi, wsAl       SRIM Fit WS name
'/*     tAir2           [mm]    Air length
'/*     tAl,tDL11,tSSD1 [um]    SSD1 Al, DeadLayer, SSD thick
'/*     hPa, degC       [hPa][C] of Air
'/*     return          [MeV/u]
'/*----------------------------------------------------------------------*/
Function e5adE_SSD1(ByVal Erng As Double, _
    ByVal wsAir, wsSi, wsAl As String, _
    ByVal tAir2, hPa, degC, tAl, tDL11, tSSD1 As Double) As Double
Dim E1, E2 As Double
    E1 = Application.Run("srEnewGas", wsAir, Erng, tAir2, hPa * 100, degC)
    E1 = Application.Run("srEnew", wsAl, E1, tAl)
    E1 = Application.Run("srEnew", wsSi, E1, tDL11)
    E2 = Application.Run("srEnew", wsSi, E1, tSSD1)
    e5adE_SSD1 = E1 - E2
End Function

'/*----------------------------------------------------------------------*/
'/*(Func.) dE in SSD2
'/*     Erng            [MeV/u] Ebeam @ EDeg out
'/*     wsAir, wsSi, wsAl       SRIM Fit WS name
'/*     tAir2           [mm]    Air length
'/*     tAl,tDL11,tSSD1,tDL12,tDL21,tSSD2 [um]
'/*                             SSD1+SSD2 Al, DeadLayer, SSD thick
'/*     hPa, degC       [hPa][C] of Air
'/*     return          [MeV/u]
'/*----------------------------------------------------------------------*/
Function e5adE_SSD2(ByVal Erng As Double, _
    ByVal wsAir, wsSi, wsAl As String, _
    ByVal tAir2, hPa, degC, tAl, tDL11, tSSD1, tDL12, tDL21, tSSD2 As Double) As Double
Dim E1, E2 As Double
    E1 = Application.Run("srEnewGas", wsAir, Erng, tAir2, hPa * 100, degC)
    E1 = Application.Run("srEnew", wsAl, E1, tAl)
    E1 = Application.Run("srEnew", wsSi, E1, tDL11)
    E1 = Application.Run("srEnew", wsSi, E1, tSSD1)
    E1 = Application.Run("srEnew", wsSi, E1, tDL12)
    E1 = Application.Run("srEnew", wsSi, E1, tDL21)
    E2 = Application.Run("srEnew", wsSi, E1, tSSD2)
    e5adE_SSD2 = E1 - E2
End Function

'/*----------------------------------------------------------------------*/
'/*(Sub.) LVlog  "̃}[N"s  PkUp ăRsy
'/* sFrWS       from V[g
'/* sFrClMk1    from }[N̗L𔻒f (󔒂łȂPkUp)
'/* iFrRwS      from ̗ Starts
'/* iFrRwE      from ̗ End  s
'/* sFrClPk1    from sŁAPkUp1
'/* sFrClPk2    from sŁAPkUp2
'/* sToRngS     to   y[Xg̐擪ʒu
'/* @BooǩĂяoF
'/* Private Sub CommandButton1_Click()
'   Call Application.Run("SRIMfit.xlsm!e5aLogPk", _
'      Range("$F$6").Value, _@`` Range("$K$13").Value) )
'   End Sub
'/*----------------------------------------------------------------------*/
Sub e5aLogPk(ByVal sFrWS As String, ByVal sFrMk As String, _
    ByVal sFrClMk As String, ByVal iFrRwS As Long, ByVal iFrRwE As Long, _
    ByVal sToRngS As String, _
    ByVal sFrClPk1 As String, ByVal sFrClPk2 As String, ByVal sFrClPk3 As String, _
    ByVal sFrClPk4 As String, ByVal sFrClPk5 As String, ByVal sFrClPk6 As String, _
    ByVal sFrClPk7 As String, ByVal sFrClPk8 As String)
Dim FrWS, ToWS As Worksheet
Dim FrRng, ToRng As Range
Dim iFrRw As Long
'       Workbook w肷ꍇ
'   Set FrWS = ThisWorkbook.Worksheets(sFrWS)
'   Set ToWS = ThisWorkbook.ActiveSheet
    Set FrWS = Worksheets(sFrWS)
    Set ToWS = ActiveSheet
    Set ToRng = Range(sToRngS)
    For iFrRw = iFrRwS To iFrRwE Step 1
      FrRng = FrWS.Cells(iFrRw, sFrClMk) ' Cells(1,1) == Cells(1,"A") sRaw,Clm̏
      If InStr(FrRng, sFrMk) Then
        ToRng.Offset(0, 0).Value = FrWS.Cells(iFrRw, sFrClPk1).Value
        ToRng.Offset(0, 1).Value = FrWS.Cells(iFrRw, sFrClPk2).Value
        ToRng.Offset(0, 2).Value = FrWS.Cells(iFrRw, sFrClPk3).Value
        ToRng.Offset(0, 3).Value = FrWS.Cells(iFrRw, sFrClPk4).Value
        ToRng.Offset(0, 4).Value = FrWS.Cells(iFrRw, sFrClPk5).Value
        ToRng.Offset(0, 5).Value = FrWS.Cells(iFrRw, sFrClPk6).Value
        ToRng.Offset(0, 6).Value = FrWS.Cells(iFrRw, sFrClPk7).Value
        ToRng.Offset(0, 7).Value = FrWS.Cells(iFrRw, sFrClPk8).Value
        Set ToRng = ToRng.Offset(1, 0)
      End If
    Next iFrRw
End Sub

'/*----------------------------------------------------------------------*/
'/*(Sub.) Ot X/Y min/max ꊇZbg
'/*     iTblCm,iTblRw   p[^TableJn ,sԍ eg.) B3 -> 2,3
'/*     nGr             Ot (p[^Table̍s)
'/*----------------------------------------------------------------------*/
Sub e5aGrAxSet(ByVal iTblCm As Integer, ByVal iTblRw As Integer, ByVal nGr As Integer)
 Dim iGr, iRw, iCm As Integer
 Dim GrNm As String
 Dim Ymin, Ymax, Xmin, Xmax As Single
 Dim MyWS As Worksheet

 Set MyWS = ActiveSheet
 iCm = iTblCm
' With ActiveSheet
   For iGr = 0 To nGr - 1
     iRw = iTblRw + iGr
     GrNm = MyWS.Cells(iRw, iCm).Value
     Xmin = MyWS.Cells(iRw, iCm + 1).Value
     Xmax = MyWS.Cells(iRw, iCm + 2).Value
     Ymin = MyWS.Cells(iRw, iCm + 3).Value
     Ymax = MyWS.Cells(iRw, iCm + 4).Value
     MyWS.ChartObjects(GrNm).Chart.Axes(xlValue).MinimumScale = Ymin
     MyWS.ChartObjects(GrNm).Chart.Axes(xlValue).MaximumScale = Ymax
     MyWS.ChartObjects(GrNm).Chart.Axes(xlCategory).MinimumScale = Xmin
     MyWS.ChartObjects(GrNm).Chart.Axes(xlCategory).MaximumScale = Xmax
   Next iGr
' End With
End Sub


